-- Exercise scripting a bit in our test-level

-- write out that we loaded sucessfully (mor or less, anyway)
io.write("Starting script for Level0 in BlinkenLUA / ",_VERSION,"!\n")

-- declare our global data structure
GLOBALS = {};


-- Required function: Initializing the level
function initLevel ()
	-- Init base striuctures
	GLOBALS.gfx = {};
	GLOBALS.snd = {};
	GLOBALS.obj = {};

	-- Init variables
	GLOBALS.hs_on = {};
	for i = 1, 5, 1 do
		GLOBALS.hs_on[i] = 0;
	end
	GLOBALS.switchon = 0;
	GLOBALS.timer = 0;
	GLOBALS.hs_switch_cnt = 0;
	GLOBALS.hs_timer = 30;
	GLOBALS.pixelAdded = 0;
	GLOBALS.pixelTimer = 0;
	GLOBALS.pixelStep = 0;
	GLOBALS.hintTimer = 1000;

    -- preload all gfx (on-the-fly loading is NOT recommended)
    GLOBALS.gfx.door_closed = LoadGFX("fg_door_closed.bmp");
    GLOBALS.gfx.door_open = LoadGFX("fg_door_open.bmp");
    GLOBALS.gfx.switch_red = LoadGFX("fg_switch_red.bmp");
    GLOBALS.gfx.switch_green = LoadGFX("fg_switch_green.bmp");
	GLOBALS.gfx.hs = {};
    GLOBALS.gfx.hs[1] = LoadGFX("fg_huntingseason.bmp");
    GLOBALS.gfx.hs[2] = LoadGFX("fg_huntingseason_neon.bmp");
	GLOBALS.gfx.progr = {};
    GLOBALS.gfx.progr[1] = LoadGFX("fg_progress_0.bmp");
    GLOBALS.gfx.progr[2] = LoadGFX("fg_progress_1.bmp");
    GLOBALS.gfx.progr[3] = LoadGFX("fg_progress_2.bmp");
    GLOBALS.gfx.progr[4] = LoadGFX("fg_progress_3.bmp");
    GLOBALS.gfx.progr[5] = LoadGFX("fg_progress_4.bmp");
    GLOBALS.gfx.progr[6] = LoadGFX("fg_progress_5.bmp");
	GLOBALS.gfx.machine = {};
    GLOBALS.gfx.machine[1] = LoadGFX("fg_machine1.bmp");
    GLOBALS.gfx.machine[2] = LoadGFX("fg_machine2.bmp");
    GLOBALS.gfx.stop = LoadGFX("fg_emergency_stop.bmp");
	GLOBALS.gfx.expl = {};
	GLOBALS.gfx.expl[0] = LoadGFX("fg_explode_0.bmp");
	GLOBALS.gfx.expl[1] = LoadGFX("fg_explode_1.bmp");
	GLOBALS.gfx.expl[2] = LoadGFX("fg_explode_2.bmp");
	GLOBALS.gfx.expl[3] = LoadGFX("fg_explode_3.bmp");
	GLOBALS.gfx.hint = LoadGFX("fg_hint_level0.jpg");

    -- create door and switch
    GLOBALS.obj.switch = AddObject(GLOBALS.gfx.switch_red, 11, 21, 0, 1, 0);
    GLOBALS.obj.door = AddObject(GLOBALS.gfx.door_closed, 13, 21, 1, 1, 1);
    GLOBALS.obj.hs_sign = AddObject(GLOBALS.gfx.hs[1], 23, 17, 0, 1, 0);

	-- create machines with switches and such
	GLOBALS.obj.hs_switch = {};
	GLOBALS.obj.machine = {};
	GLOBALS.obj.expl = {};
		-- Machine parts over start location
    AddObject(GLOBALS.gfx.machine[1], 1, 17, 0, 1, 0);
    GLOBALS.obj.hs_switch[1] = AddObject(GLOBALS.gfx.switch_red, 2, 17, 0, 1, 0);
    AddObject(GLOBALS.gfx.machine[1], 3, 17, 0, 1, 0);
    AddObject(GLOBALS.gfx.machine[2], 4, 17, 0, 1, 0);
    AddObject(GLOBALS.gfx.machine[1], 5, 17, 0, 1, 0);

		-- Machine parts below sign	
    AddObject(GLOBALS.gfx.machine[2], 23, 21, 0, 1, 0);
    AddObject(GLOBALS.gfx.machine[1], 24, 21, 0, 1, 0);
    AddObject(GLOBALS.gfx.machine[1], 25, 21, 0, 1, 0);
    GLOBALS.obj.hs_switch[2] = AddObject(GLOBALS.gfx.switch_red, 26, 21, 0, 1, 0);
    AddObject(GLOBALS.gfx.machine[2], 27, 21, 0, 1, 0);
    GLOBALS.obj.hs_switch[3] = AddObject(GLOBALS.gfx.switch_red, 28, 21, 0, 1, 0);
    AddObject(GLOBALS.gfx.machine[1], 29, 21, 0, 1, 0);
    GLOBALS.obj.hs_switch[4] = AddObject(GLOBALS.gfx.switch_red, 30, 21, 0, 1, 0);
    GLOBALS.obj.progr =  AddObject(GLOBALS.gfx.progr[1], 31, 21, 0, 1, 0);
    GLOBALS.obj.hs_switch[5] = AddObject(GLOBALS.gfx.switch_red, 32, 21, 0, 1, 0);
    AddObject(GLOBALS.gfx.machine[2], 33, 21, 0, 1, 0);
    GLOBALS.obj.stop = AddObject(GLOBALS.gfx.stop, 34, 21, 0, 1, 0);
    AddObject(GLOBALS.gfx.machine[2], 35, 21, 0, 1, 0);
    AddObject(GLOBALS.gfx.machine[1], 36, 21, 0, 1, 0);
    GLOBALS.obj.expl[1] = AddObject(GLOBALS.gfx.expl[0], 36, 21, 0, 0, 1);
    GLOBALS.obj.expl[2] = AddObject(GLOBALS.gfx.expl[0], 29, 21, 0, 0, 1);
    AddObject(GLOBALS.gfx.hint, 2, 10, 0, 1, 0);

   -- load extra sound
   GLOBALS.snd.door_open = LoadSoundFX("fx_open_door.ogg");
   GLOBALS.snd.door_close = LoadSoundFX("fx_open_door.ogg");
   GLOBALS.snd.switch = LoadSoundFX("fx_collect_pixel.ogg");
   GLOBALS.snd.stop = LoadSoundFX("fx_kill_monster.ogg");
   GLOBALS.snd.expl = LoadSoundFX("fx_close_door.ogg");
   GLOBALS.snd.hint = LoadSoundFX("fx_level0_hint.ogg");

   -- Register additional pixel
   IncMaxPixels(1);
end

-- Required function: Physics-loop for scripting part
function scriptPhysics ()
    if GLOBALS.switchon == 1 then
        -- Block the door after a certain time
        GLOBALS.timer = GLOBALS.timer - 1;
        if GLOBALS.timer == 0 then
            closeDoor();
        end
    end
    if GLOBALS.hs_switch_cnt == 5 then
        GLOBALS.hs_timer = GLOBALS.hs_timer - 1;
        if GLOBALS.hs_timer == 0 then
            GLOBALS.hs_timer = 200;
            SetGFX(GLOBALS.obj.hs_sign, GLOBALS.gfx.hs[2]);
        end
        if GLOBALS.hs_timer == 150 then
            SetGFX(GLOBALS.obj.hs_sign, GLOBALS.gfx.hs[1]);
        end
    end
	if GLOBALS.pixelTimer > 0 then
		GLOBALS.pixelTimer = GLOBALS.pixelTimer - 1;
		if GLOBALS.pixelTimer == 0 then
			GLOBALS.pixelStep = GLOBALS.pixelStep + 1;
			if GLOBALS.pixelStep == 1 then
				SetGFX(GLOBALS.obj.expl[1], GLOBALS.gfx.expl[1]);
				SetGFX(GLOBALS.obj.expl[2], GLOBALS.gfx.expl[1]);
				GLOBALS.pixelTimer = 10;
			end
			if GLOBALS.pixelStep == 2 then
				SetGFX(GLOBALS.obj.expl[1], GLOBALS.gfx.expl[2]);
				SetGFX(GLOBALS.obj.expl[2], GLOBALS.gfx.expl[2]);
				GLOBALS.pixelTimer = 10;
			end
			if GLOBALS.pixelStep == 3 then
				SetGFX(GLOBALS.obj.expl[1], GLOBALS.gfx.expl[3]);
				SetGFX(GLOBALS.obj.expl[2], GLOBALS.gfx.expl[3]);
				AddPixel(36, 21);
				AddBonusLive(29, 21);
				GLOBALS.pixelTimer = 10;
			end
			if GLOBALS.pixelStep == 4 then
				SetGFX(GLOBALS.obj.expl[1], GLOBALS.gfx.expl[2]);
				SetGFX(GLOBALS.obj.expl[2], GLOBALS.gfx.expl[2]);
				GLOBALS.pixelTimer = 10;
			end
			if GLOBALS.pixelStep == 5 then
				SetGFX(GLOBALS.obj.expl[1], GLOBALS.gfx.expl[1]);
				SetGFX(GLOBALS.obj.expl[2], GLOBALS.gfx.expl[1]);
				GLOBALS.pixelTimer = 10;
			end
			if GLOBALS.pixelStep == 6 then
				SetGFX(GLOBALS.obj.expl[1], GLOBALS.gfx.expl[0]);
				SetGFX(GLOBALS.obj.expl[2], GLOBALS.gfx.expl[0]);
				GLOBALS.pixelTimer = 10;
			end
			if GLOBALS.pixelStep == 7 then
				SetVisible(GLOBALS.obj.expl[1], 0);
				SetVisible(GLOBALS.obj.expl[2], 0);
			end
		end
	end

	if GLOBALS.pixelAdded == 0 then
		GLOBALS.hintTimer = GLOBALS.hintTimer - 1;
		if GLOBALS.hintTimer == 0 then
			PlaySoundFX(GLOBALS.snd.hint);
			GLOBALS.hintTimer = 3000;
		end
	end
	
end

-- Required function: Callback on "Action"-Button on FG-Objects
function handleAction (obj_id)
    -- Open door if not open
    if obj_id == GLOBALS.obj.switch and GLOBALS.switchon == 0 then
        openDoor();
    end
    if obj_id == GLOBALS.obj.stop then
        SetGFX(GLOBALS.obj.hs_switch[1], GLOBALS.gfx.switch_red);
        SetGFX(GLOBALS.obj.hs_switch[2], GLOBALS.gfx.switch_red);
        SetGFX(GLOBALS.obj.hs_switch[3], GLOBALS.gfx.switch_red);
        SetGFX(GLOBALS.obj.hs_switch[4], GLOBALS.gfx.switch_red);
        SetGFX(GLOBALS.obj.hs_switch[5], GLOBALS.gfx.switch_red);
        SetGFX(GLOBALS.obj.hs_sign, GLOBALS.gfx.hs[1]);

		if GLOBALS.pixelAdded == 0 and GLOBALS.hs_timer > 150 then
			GLOBALS.pixelAdded = 1;
			GLOBALS.pixelTimer = 10;
			SetVisible(GLOBALS.obj.expl[1], 1);
			SetVisible(GLOBALS.obj.expl[2], 1);
		    PlaySoundFX(GLOBALS.snd.expl);
		end

       -- play sound
       PlaySoundFX(GLOBALS.snd.stop);

       GLOBALS.hs_switch_cnt = 0;
	   for i = 1, 5, 1 do
		  GLOBALS.hs_on[i] = 0;
	   end
       GLOBALS.hs_timer = 30;
    end
    if obj_id == GLOBALS.obj.hs_switch[1] and GLOBALS.hs_on[1] == 0 then
        -- exchange GFX for door and button
        SetGFX(GLOBALS.obj.hs_switch[1], GLOBALS.gfx.switch_green);

       -- play sound
       PlaySoundFX(GLOBALS.snd.switch);

       GLOBALS.hs_on[1] = 1;
       GLOBALS.hs_switch_cnt = 1 + GLOBALS.hs_switch_cnt;
    end
    if obj_id == GLOBALS.obj.hs_switch[2] and GLOBALS.hs_on[2] == 0 then
        -- exchange GFX for door and button
        SetGFX(GLOBALS.obj.hs_switch[2], GLOBALS.gfx.switch_green);

       -- play sound
       PlaySoundFX(GLOBALS.snd.switch);

       GLOBALS.hs_on[2] = 1;
       GLOBALS.hs_switch_cnt = 1 + GLOBALS.hs_switch_cnt;
    end
    if obj_id == GLOBALS.obj.hs_switch[3] and GLOBALS.hs_on[3] == 0 then
        -- exchange GFX for door and button
        SetGFX(GLOBALS.obj.hs_switch[3], GLOBALS.gfx.switch_green);

       -- play sound
       PlaySoundFX(GLOBALS.snd.switch);

       GLOBALS.hs_on[3] = 1;
       GLOBALS.hs_switch_cnt = 1 + GLOBALS.hs_switch_cnt;
    end
    if obj_id == GLOBALS.obj.hs_switch[4] and GLOBALS.hs_on[4] == 0 then
        -- exchange GFX for door and button
        SetGFX(GLOBALS.obj.hs_switch[4], GLOBALS.gfx.switch_green);

       -- play sound
       PlaySoundFX(GLOBALS.snd.switch);

       GLOBALS.hs_on[4] = 1;
       GLOBALS.hs_switch_cnt = 1 + GLOBALS.hs_switch_cnt;
    end
    if obj_id == GLOBALS.obj.hs_switch[5] and GLOBALS.hs_on[5] == 0 then
        -- exchange GFX for door and button
        SetGFX(GLOBALS.obj.hs_switch[5], GLOBALS.gfx.switch_green);

       -- play sound
       PlaySoundFX(GLOBALS.snd.switch);

       GLOBALS.hs_on[5] = 1;
       GLOBALS.hs_switch_cnt = 1 + GLOBALS.hs_switch_cnt;
    end
    if GLOBALS.hs_switch_cnt == 0 then
        SetGFX(GLOBALS.obj.progr, GLOBALS.gfx.progr[1]);
    end
    if GLOBALS.hs_switch_cnt == 1 then
        SetGFX(GLOBALS.obj.progr, GLOBALS.gfx.progr[2]);
    end
    if GLOBALS.hs_switch_cnt == 2 then
        SetGFX(GLOBALS.obj.progr, GLOBALS.gfx.progr[3]);
    end
    if GLOBALS.hs_switch_cnt == 3 then
        SetGFX(GLOBALS.obj.progr, GLOBALS.gfx.progr[4]);
    end
    if GLOBALS.hs_switch_cnt == 4 then
        SetGFX(GLOBALS.obj.progr, GLOBALS.gfx.progr[5]);
    end
    if GLOBALS.hs_switch_cnt == 5 then
        SetGFX(GLOBALS.obj.progr, GLOBALS.gfx.progr[6]);
    end

end

-- Script-internal functions
function openDoor()
    GLOBALS.switchon = 1;

    -- exchange GFX for door and button
    SetGFX(GLOBALS.obj.switch, GLOBALS.gfx.switch_green);
    SetGFX(GLOBALS.obj.door, GLOBALS.gfx.door_open);

    -- make door nonblocking
    SetBlocking(GLOBALS.obj.door, 0);
    GLOBALS.timer = 250; -- 5 secs    

   -- play sound
   PlaySoundFX(GLOBALS.snd.door_open);
end

function closeDoor()
    GLOBALS.switchon = 0;

    -- exchange GFX for door and button
    SetGFX(GLOBALS.obj.switch, GLOBALS.gfx.switch_red);
    SetGFX(GLOBALS.obj.door, GLOBALS.gfx.door_closed);

    -- Block the door again
    SetBlocking(GLOBALS.obj.door, 1);

   -- play sound
   PlaySoundFX(GLOBALS.snd.door_close);
end
